/*****************************************************************************
 *
 * Main entry into the application.
 *
 *****************************************************************************
 * FileName:        main_solution.c
 * Dependencies:    p24FJ128GA010.h, lcd.h
 * Processor:		PIC24FJ128GA010
 * IDE :       	    MPLAB v8.10 or higher
 * Compiler :       MPLAB C30 v3.10 or higher
 * HW platform :    EXPLORER16 (DM240001)
 * Plug-In Module : PIC24FJ128GA010 PIM Plug-In Module (MA240011)    
 * Company:         Microchip Technology Incorporated
 *
 * Software License Agreement
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the "Company") is intended and supplied to you, the Company's
 * customer, for use solely and exclusively with products manufactured
 * by the Company. 
 *
 * The software is owned by the Company and/or its supplier, and is 
 * protected under applicable copyright laws. All rights are reserved. 
 * Any use in violation of the foregoing restrictions may subject the 
 * user to criminal sanctions under applicable laws, as well as to 
 * civil liability for the breach of the terms and conditions of this 
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES, 
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED 
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT, 
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR 
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 *
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Ross Fosler			06/07/05	...	
 * Brant Ivey			7/3/07		Updated for v2.0 of class
 * Alain Sorin          7/Dec/07    Updated for v3.10 of 204_ADV class
 * Alain Sorin         28/Feb/09    Updated for v4.00 of MCU_3122 class (renamed)
 *****************************************************************************/

#include	<p24FJ128GA010.h>
#include	"lcd.h"

_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & ICS_PGx2 & FWDTEN_OFF)
_CONFIG2(IESO_OFF & FCKSM_CSDCMD & OSCIOFNC_ON &  FNOSC_PRI & POSCMOD_HS)


//********************************************************************************

//***********************************************************
// STEP 5:
// Change string "Your Name" to your name
//***********************************************************/
const unsigned char my_name[] = "Your Name";    //  ### enter your name here
const unsigned char * pname;


// Extra Credit Variables
const unsigned char my_banner[][24] = {"Banner 1", "Banner 2", "Banner 3"};	// Banners to display
const unsigned char * pban;													// Pointer to char of current banner
unsigned int num_banners;													// Number of banners to display
unsigned int i;																// Banner counter
unsigned int wait_time = 0;													// Time delay counter
//**************************************************************************************************************


int main(void)
{
	// Setup the LCD
	mLCDInit();

	// Setup string pointers and lengths
	pname = my_name;

	// Setup extra credit variables
	pban = *my_banner;
	num_banners = sizeof(my_banner)/24;


	while (1) {
		// Process LCD events
		LCDProcessEvents();

		// Display name string once at reset
		if ((!mLCDIsBusy()) && (*pname)) {
			mLCDPutChar(*pname++);
		}

//******************************************************************************************************
// Extra credit:
// Uncomment this code and modify it to display the rotating banners in my_banner.
// Useful variables and functions: pban, ban_len, num_banners, wait_time, mLCDPutChar(char), mLCDClear()
//******************************************************************************************************
//		// Display rotating banners
//		if (!mLCDIsBusy()){
//			if(*pban) {						// Print current banner
//				mLCDPutChar(*pban);
//				pban++;
//			}else if(!wait_time){			// Increment to next banner after some time
//				mLCDClear();
//				if(i >= num_banners) i=0;
//				pban = my_banner[i++];
//			}
			
//			wait_time++;
//		}
//******************************************************************************************************
	}
}
