/*****************************************************************************
 *
 * Explorer 16 Development Board Demo Program.
 *
 *****************************************************************************
 * FileName:        main.c
 * Dependencies:    system.h
 * Processor:		PIC24FJ128GA010
 * IDE :       	    MPLAB v8.10 or higher
 * Compiler :       MPLAB C30 v3.10 or higher
 * HW platform :    EXPLORER16 (DM240001)
 * Plug-In Module : PIC24FJ128GA010 PIM Plug-In Module (MA240011)
 * Company:         Microchip Technology Incorporated
 *
 * Software License Agreement
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the "Company") is intended and supplied to you, the Company's
 * customer, for use solely and exclusively with products manufactured
 * by the Company. 
 *
 * The software is owned by the Company and/or its supplier, and is 
 * protected under applicable copyright laws. All rights are reserved. 
 * Any use in violation of the foregoing restrictions may subject the 
 * user to criminal sanctions under applicable laws, as well as to 
 * civil liability for the breach of the terms and conditions of this 
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES, 
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED 
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT, 
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR 
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Ross Fosler	        XXX         ...	
 * Anton Alkhimenok     10/21/05    ...
 * Brant Ivey			7/3/07		Updated for v2.0 of class
 * Alain Sorin          7/Dec/07    Updated for v3.10 of 204_ADV class 
 * Alain Sorin          28/Feb/09   Updated to v4.00 of MCU 3122 RTC class
 *****************************************************************************/

#include "system.h"

// Setup configuration bits
_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & ICS_PGx2 & FWDTEN_OFF)
_CONFIG2(IESO_OFF & FCKSM_CSDCMD & OSCIOFNC_ON &  FNOSC_PRI & POSCMOD_HS)


int main(void)
{
    
	// Setup the LCD
	mLCDInit();

    // Setup the RTCC
    RTCCInit();
	TRISA = 0xFF80;                     // set LATA <6:0> as outputs 
	TBannerInit();

	while (1) {
		//LCD Processing
		LCDProcessEvents();
       
		//Time Processing
		TBannerProcessEvents();

		if (IFS3bits.RTCIF == 1)		// RTCC interrupt flag set ?
		{
			unsigned long int i;        // yes
			IFS3bits.RTCIF = 0;			// clear RTCC interrupt flag
			LATAbits.LATA4 = 1;			// LED ON
			for(i=0; i<100000; i++) ; 	// delay here for LED
			LATAbits.LATA4 = 0;			// LED OFF
		}
    }// End of while(1)...
}// End of main()...
